require 'foursquare2'

def create_node_data(user)
  {
    id: user[:id],
    checkins: user[:checkins][:count],
    gender: user[:gender]
  }
end

nodes = []
links = []

limit = 8

client = Foursquare2::Client.new(
  oauth_token: '2PEXOJ5TXZ2HZKSVSD5JETWJ1TJQIYQJWY53WHEI1HCNW1QR'
)

user_l1 = client.user('self')
sleep 10

node_l1 = create_node_data(user_l1)
index_l1 = nodes.count
nodes << node_l1

friends_l1 = client.user_friends(node_l1[:id], limit: limit)
friends_l1[:items].each do |u|
  fetch = false
  unless nodes.any? {|node| node[:id] == u[:id]}
    user_l2 = client.user(u[:id])
    sleep 10

    node_l2 = create_node_data(user_l2)
    index_l2 = nodes.count
    nodes << node_l2

    fetch = true
  else
    index_l2 = nodes.index {|node| node[:id] == u[:id]}
  end

  unless links.any? {|link| link[:source] == index_l2 && link[:target] == index_l1}
    links << {
      source: index_l1,
      target: index_l2
    }
  end

  if fetch
    friends_l2 = client.user_friends(node_l2[:id], limit: limit)
    friends_l2[:items].each do |u2|
      fetch_2 = false
      unless nodes.any? {|node| node[:id] == u2[:id]}
        user_l3 = client.user(u2[:id])
        sleep 10

        node_l3 = create_node_data(user_l3)
        index_l3 = nodes.count
        nodes << node_l3

        fetch_2 = true
      else
        index_l3 = nodes.index {|node| node[:id] == u2[:id]}
      end

      unless links.any? {|link| link[:source] == index_l3 && link[:target] == index_l2}
        links << {
          source: index_l2,
          target: index_l3
        }
      end

      if fetch_2
        friends_l3 = client.user_friends(node_l3[:id], limit: limit)
        friends_l3[:items].each do |u3|
          unless nodes.any? {|node| node[:id] == u3[:id]}
            user_l4 = client.user(u3[:id])
            sleep 10

            node_l4 = create_node_data(user_l4)
            index_l4 = nodes.count
            nodes << node_l4

          else
            index_l4 = nodes.index {|node| node[:id] == u3[:id]}
          end

          unless links.any? {|link| link[:source] == index_l4 && link[:target] == index_l3}
            links << {
              source: index_l3,
              target: index_l4
            }
          end
        end
      end
    end
  end
end

result = {nodes: nodes, links: links}

puts result.to_json
